
// forall d:Door . d = Open => [CloseDoor(d)] d = Closed
function CloseDoor(d,a) = {
	switch
	case (d,a1):hasauthority and (a1,a):overruledby => rawCloseDoor(d,a)
	case (d,a1):hasauthority and a1!=a => skip
	case _ => rawCloseDoor(d,a)
}

action rawCloseDoor(d,a) = 
{
pre = d:Door, a:Authority
effect = d:Closed, (d,a):hasauthority
}

// forall d:Door . d = Closed => [OpenDoor(d)] d = Open
function OpenDoor(d,a) = {
	switch
	case (d,a1):hasauthority and (a1,a):overruledby => rawOpenDoor(d,a)
	case (d,a1):hasauthority and a1!=a => skip
	case _ => rawOpenDoor(d,a)
}

action rawOpenDoor(d,a) = 
{
pre = d:Door, a:Authority
effect = d:Open, (d,a):hasauthority
}

function LightOn(l,authority) = 
{
  switch
	case (l,auth):hasauthority and (auth,authority):overruledby => rawLightOn(l,authority)
	case (l,auth):hasauthority and auth!=authority => skip
	case _ => rawLightOn(l,authority)
}


action rawLightOn(l,authority) = 
{
	pre = l:AbstractLight
	effect = (l,authority):hasauthority
	if (l:Light) l:On
	if (l:DimLight) l:DimOn
	if (l:NoBlink) l:Blink
}

function LightOff(l,authority) = 
{
  switch
	case (l,auth):hasauthority and (auth,authority):overruledby => rawLightOff(l,authority)
	case (l,auth):hasauthority and auth!=authority => skip
	case _ => rawLightOff(l,authority)
}

action rawLightOff(l,authority) = 
{
	pre = l:AbstractLight
	effect = (l,authority):hasauthority
	if (l:Light) l:Off
	if (l:DimLight) l:DimOff
	if (l:Blink) l:NoBlink
}

/*
 =====================================================
*/

function Control(time,aemergency) = 
{
  switch 
  case time:Day => init NightComes(time) ; Control(time,aemergency) 
  case situation:Emergency => skip
	case time:Night and situation:Normal => {
		allLightsOff(aemergency) | CloseAllDoors(aemergency)
		}
/*		
  case time:Night and d:Open => CloseDoor(d,aemergency) ; Control(time)
  case time:Night and l:AbstractOn => LightOff(l,aemergency) ; Control(time)
  case time:Night and d:Closed => skip
	*/
}

function Emergency (sit,time,aemergency) = 
{
 init EmergencyHappens(sit,time) ;
 switch 
  case time:Day => skip //System(sit,time)
	case time:Night => {
		{ forall l:AbstractOff => LightOn(l,aemergency) }
		|
		{ forall l:AbstractOn and (l,a1):hasauthority and (a1,a):overruledby => LightOn(l,aemergency) }
		|
		{ forall d:Closed => OpenDoor(d,aemergency) }	
		|
		{ forall d:Open and (d,a1):hasauthority and (a1,a):overruledby => OpenDoor(d,aemergency) }	
		};
/*
  case l:AbstractLight and l:AbstractOff => LightOn(l,aemergency) ; Emergency(sit,time)
  case d:Door and d:Closed => OpenDoor(d) ; Emergency(sit,time)
  case d:Door and d:Open =>
*/
      init EmergencyMonitor(sit,time) ;
			{ switch
			  case time:Day => allLightsOff(aemergency)
			  case _ => skip
			}
}

/* function illuminateArea (a) = {
 forall l:Off and (l,a):associated_light => LightOn(l) 
}

function obscureArea (a) = {
 forall l:On and (l,a):associated_light => LightOff(l) 
}*/

function allLightsOff (aemergency) = {
 { forall l:AbstractOn  => LightOff(l,aemergency) }
 |
 { forall l:AbstractOff and (l,a1):hasauthority and (a1,aemergency):overruledby => LightOff(l,aemergency) }
}

function CloseAllDoors (aemergency) = 
{
	{ forall d:Open => CloseDoor(d,aemergency) }
	|
	{ forall d:Closed and (d,a1):hasauthority and (a1,aemergency):overruledby => CloseDoor(d,aemergency) }	
}

function DoorControl(sit,time,aemergency) = 
{
	switch
	case sit:Emergency => skip
	case time:Night => {
		(init MonitorDoors(sit,time)) 
		+ 
		{
			switch
			case sit:Emergency => skip
		  case _ => {CloseAllDoors(aemergency); DoorControl(sit,time,aemergency)}
		}
  }
	case _ => skip
}

/*WAS  As if

function DoorControl(sit,time) = 
{
  if (sit:Emergency) skip
  else { if (time:Night) 
   (
   (init MonitorDoors(sit,time)) 
   + 
   (if (sit:Emergency) skip else (CloseAllDoors; DoorControl(sit,time)))
   )
  else skip
  }
}

*/
function System (sit,time,aemergency) = 
{
 Control(time,aemergency); 
 (Emergency(sit,time,aemergency) 
  | 
  DoorControl(sit,time,aemergency)
 ); 
 System(sit,time,aemergency)
}

/* Switching authority rules */

function controlAuthorities(sit,aemergency,atransport) = {
	{
		switch
		case sit:Emergency and (aemergency,atransport):ruledby
		     => emergencyInControl(sit,aemergency,atransport)
		case sit:Normal and (atransport,aemergency):ruledby
		     => transportInControl(sit,aemergency,atransport)
	};
	controlAuthorities(sit,aemergency,atransport)
}

action emergencyInControl (sit,aemergency,atransport) = {
	pre = 
	effect = sit:Emergency, (atransport,aemergency):ruledby, not (aemergency,atransport):ruledby
	}

action transportInControl (sit,aemergency,atransport) = {
	pre =
	effect = sit:Normal, (aemergency,atransport):ruledby, not (atransport,aemergency):ruledby
	}






