action AskEKGState(p) = {
pre =  (p, addsy1):HasAdditionalSymptoms , (p,sy1):HasAcsSymptoms , (p, pro1):HasTreatment ,  (p, d1):HasDiagnosis 
effect = p:GetDiagnosisBasedOnEKGState
  }

action  AskPCIPossible(p) ={ 

pre    = p:Patient, d:STEMI, (p,d):HasDiagnosis 
effect = p:IsPCITime
}

action  AskImmFibSuccessful(p) = { 

pre    = p:Patient, immFib:ImmFib, (immFib, p):HasExecuted
effect =  p:IsimmFibS
}



action ExecuteImmFib(p) = {

pre = p:Patient, immFib:ImmFib
effect = (immFib,p):Execute, (p, immFib):HasTreatment 
}

action  StartPCITherapy(p) = {
pre    = p:Patient, pCI:PCI , (p, pCI):HasTreatment
effect =  t:UnkonwnTime  , (p, t):WaitSince, sy:UnknownAcsSymptom, (p, sy):HasSymptoms , th:UnknownTherapy , (p, th):HasTherapy, no:ContraindicationForAspirinUnknown , (p,no):HasContraindication

}

function StartProcedure (p) = {
  switch 
  case    pci:PCI and (p, pci):HasTreatment => ( StartPCITherapy(p); ObservePCITherapy(p))
//  case    pci:PCI and (p, pci):HasTreatment => ( StartPCITherapy(p); ObserveTreatment(p, pci))   //ObserveTherapy(p, pci)
  case _ => ( StartPCITherapy(p); ObservePCITherapy(p))   //FIXME
  }

action ExecuteCoroAngiography(p) = {
pre   =    p:Patient,  d:STEMI,  immFib:ImmFib, coroAngiography:CoroAngiography, (p, d):HasDiagnosis
effect = (coroAngiography, p):Execute, (p, coroAngiography):HasTreatment

}




function STEMIForwardTreatment(p) = {

ExecuteImmFib(p);
AskImmFibSuccessful(p);

switch
	case p:immFibS => ExecuteCoroAngiography(p)
	case not p:immFibS => StartPCITheraby(p)
}


function STEMITreatment(p) = {

AskPCIPossible(p);
switch
	case  pci:PCI and (p, pci):HasProcedureExecutionWithinTime => ShowGuidelineRecommendationSTEMI(p)
  case  pci:PCI and (p, pci):HasProcedureExecutionNotWithinTime  => ( ShowGuidelineRecommendationSTEMI(p) ;  STEMIForwardTreatment(p))
}

function ShowGuidelineRecommendationSTEMI(p)={
(switch 
case  pci:PCI and (p, pci):HasProcedureExecutionWithinTime and  d:STEMI  and (p,d):HasDiagnosis => ( GuidelineRecommendationSTEMIPCI(p); TreatmentDisicion(p))
)
|
(switch
case pci:PCI and (p, pci):HasProcedureExecutionNotWithinTime and  d:STEMI  and (p,d):HasDiagnosis => (GuidelineRecommendationSTEMIImmFib(p); TreatmentDisicion(p))
)

}

action  GuidelineRecommendationSTEMIPCI (p) = {
pre    = 
effect = p:GuidelineRecommendationPCI
}

action  GuidelineRecommendationSTEMIImmFib (p) = {
pre    = 
effect = p:GuidelineRecommendationImmFib
}


//---------------------------------------------------------------------
//  Non Stable 
//---------------------------------------------------------------------

function NSTEMITreatment(p) = {

AskGraceRiskScore (p);
switch
	case  g:GraceRiskScoreLow  and (p, g):HasGraceRiskScore => AdditionalCriteria(p)    
	case  g:GraceRiskScoreHigh and (p, g):HasGraceRiskScore => AdditionalCriteria(p) 
  
 }

action AskGraceRiskScore (p) = {
pre    =  d:NSTEMI, (p, d):HasDiagnosis
effect = p:GetGraceRiskScore 
}
 

function AdditionalCriteria (p) = {

AskAdditionalCriteria(p);
switch
case h:AdditionalCirteriaExist  and (p, h):HasPatientCriteria       => (deleteCriteria(p,h); AdditionalCriteria(p)) 
case h:NoAdditionalCriteria     and (p, h):HasPatientCriteria       => ShowGuidelineRecommendationNSTEMI(p,h)

}

action AskAdditionalCriteria (p) ={
pre    = 
effect = p:AnyAdditionalCriteria 

}

action deleteCriteria(p,h) =
{
pre =
effect =   h:UnknownPatientCriteria, p:UnknownAdditionalCriteria

}


function ShowGuidelineRecommendationNSTEMI (p,h) = {
(switch 
case h:NoAdditionalCriteria and (p, h):HasPatientCriteria and g:GraceRiskScoreHigh and (p, g):HasGraceRiskScore => (GuidelineRecommendationInvasiveCase1(p,h); TreatmentDisicion(p))
)
|
(switch 
case  no:NoAdditionalCriteria    and (p, no):HasPatientCriteria and low:GraceRiskScoreLow and (p, low):HasGraceRiskScore  => ( GuidelineRecommendationNoInvasiveCase2 ;TreatmentDisicion(p) )

)
|

(switch
case   h:MultipleHighRiskCriteria and (p, h):HasAdditionalCriteria  => (GuidelineRecommendationEarlyInvasive(p,h); TreatmentDisicion(p)  )
)
|
(switch
case  h:HighIschmaemicRisk and  (p, h):HasAdditionalCriteria        => ( GuidelineRecommendationEmergentCaro(p,h); TreatmentDisicion(p) )
)
|
(switch
case h:RecurrentSymptoms and (p, h):HasAdditionalCriteria  => (GuidelineRecommendationLateInvasive(p,h); TreatmentDisicion(p))
)
|

(switch 
 case  highrisk:HighRiskForInvasiveDiagnosis and (p, highrisk):HasAdditionalCriteria  => (GuidelineRecommendationNoInvasiveCase1;  TreatmentDisicion(p) ) 

)

}


action GuidelineRecommendationNoInvasiveCase1 (p,h)= {
pre    =   h:HighRiskForInvasiveDiagnosis, (p, h):HasAdditionalCriteria
effect =   p:NoInvasiveTreatmentIsRecommanded 

}
action GuidelineRecommendationNoInvasiveCase2 (p,h)= {
pre    =  h:NoAdditionalCriteria , (p, h):HasPatientCriteria, g:GraceRiskScoreLow, (p, g):HasGraceRiskScore
effect =   p:NoInvasiveTreatmentIsRecommanded 

}





action GuidelineRecommendationEmergentCaro (p,h) = {
pre    =  h:HighIschmaemicRisk, (p, h):HasAdditionalCriteria
effect =  p:GuidelineRecommendationInvasiveTreatment
}

action GuidelineRecommendationEarlyInvasive (p,h) = {
pre    = h:MultipleHighRiskCriteria, (p, h):HasAdditionalCriteria 
effect = p:GuidelineRecommendationInvasiveTreatment
}

action GuidelineRecommendationLateInvasive (p,h) = {
pre    =  h:RecurrentSymptoms, (p, h):HasAdditionalCriteria
effect = p:GuidelineRecommendationInvasiveTreatment
}

action GuidelineRecommendationInvasiveCase1 (p,h) = {
pre    =  h:NoAdditionalCriteria , (p, h):HasPatientCriteria , g:GraceRiskScoreHigh , (p, g):HasGraceRiskScore
effect =  p:GuidelineRecommendationInvasiveTreatment 

}

function TreatmentDisicion (p) = {
AskTreatmentDisicion  (p);
switch
case p:EndTreatment => skip
}

action AskTreatmentDisicion (p) = {
pre    =  
effect = p:SelectTreatmentStrategy

}

//---------------------------------------------------------------------
//  Stable CAD
//---------------------------------------------------------------------
function StableCADTreatment(p) = {

CheckSymptomsForRev(p);

switch
	case s:SymptomsForRev and (p,s):HasAcsSymptoms     => ( ShowGuidelineRecommendationOMT(p);  AddPatientSymptoms(p))
	case s:SymptomsForOMT and (p,s):HasAcsSymptoms     => (ShowGuidelineRecommendationOMT(p);  TreatmentDisicion(p))
}



function AddPatientSymptoms(p) = {

AskPatientSymptoms(p);
switch
 case o:OtherSymptoms and (p,o):HasAdditionalSymptoms =>  (DeleteRequest(o,p); AddPatientSymptoms(p))
 case o:NoOtherSymptoms and  (p,o):HasAdditionalSymptoms  =>  ShowGuidelineRecommendation(p)
}

function SelectRevascularisationProcedure(p) = {

AskTreatmentDisicion(p);
switch
case pc:PCI and (p,pci):HasTreatment     => ( RecommandedProcedureTherapy (p);   StartProcedure(p))
//case  p:CABGRequirementFulfilled     => (init HoldSymptomsCheck(p) + RegisterTimeStamp(p)); ExecuteCABG(p)
//case  p:InitialRequirementFulfilled  =>  ExecuteRevProcedure(p)
}


action DeleteRequest (o,p) = {
pre    = 
effect = o:UnknownAdditionalSym, p:UnknownPatientSymptoms
}

action  CheckSymptomsForRev(p) ={ 

pre    = d:StableCAD, (p,d):HasDiagnosis 
effect = p:AnySymptomsOccured 
}





action AskPatientSymptoms(p) ={
pre    =   d:StableCAD,  (p, d):HasDiagnosis
effect =   p:GetPatientSymptoms 
}


action ShowGuidelineRecommendationPCI(p) = {
pre    =  
effect =   p:GuidelineRecommendationPCI 

}
action ShowGuidelineRecommendationOMT(p) = {
pre    =   
effect =   p:GuidelineRecommendationOMT

}

action ShowGuidelineRecommendationCABG(p) = {
pre    =   
effect =   p:GuidelineRecommendationCABG 

}

action ShowGuidelineRecommendationUnknown(p) = {
pre    =   
effect =   p:GuidelineRecommendationUnknown 
}


function RecommandedProcedureTherapy (p) ={
  switch
    case p:Patient and pci:PCI and (p, pci):HasTreatment => ShowGuildelineRecommendationPCITherapy (p)
  }

action ShowGuildelineRecommendationPCITherapy  (p) ={
  pre    =  p:Patient, pci:PCI, (p, pci):HasTreatment
  effect =  p:PCITherapyAspirn_Clopidogrel_GPIIb_Heparin_Bivalirudin
}


function ShowGuidelineRecommendation(p) = {
switch
case    d:StableCAD and  (p, d):HasDiagnosis and s1:NonProximalLAD and (p, s1):HasAcsSymptoms  => ( ShowGuidelineRecommendationPCI(p); SelectRevascularisationProcedure(p))

case d:StableCAD and  (p, d):HasDiagnosis and s2:ProximalLad and (p,s2):HasAcsSymptoms =>( ShowGuidelineRecommendationCABG(p); SelectRevascularisationProcedure(p))
case   d:StableCAD and  (p, d):HasDiagnosis and s4:S4 and (p,s4):HasAcsSymptoms  =>  ShowGuidelineRecommendationUnknown(p)
}

action ExecuteOMT(p) = {
pre    =  omt:OMT,  d:StableCAD,  (p, d):HasDiagnosis
effect = (omt, p):Execute , (p, omt):HasTreatment
}

action ExecuteRevProcedure(p) = {
pre    =   s:S3,   d:StableCAD,  (p, d):HasDiagnosis
effect = p:PCIorCABGCanBeExecuted

}

action RegisterTimeStamp(p) = {
pre     =  d:Diagnosis, (p,d):HasDiagnosis
effect  = p:ViolationOfGuidelineIsOccured 

}




action RegisterPatient (p) =
{
pre =
effect = p:Patient, d1:UnknownDiagnosis, pro1:UnknownProcedure, addsy1:UnknownAdditionalSym, sy1:UnknownSymptom, (p, addsy1):HasAdditionalSymptoms,
(p,sy1):HasAcsSymptoms,
(p, pro1):HasTreatment,
(p, d1):HasDiagnosis
  
}


action DiagnoseSTABLE(p) =
{
pre =  d1:UnknownDiagnosis, (p,d1):HasDiagnosis
effect =  d1:StableCAD, (p,d1):HasDiagnosis
}

action SymptomsforRevascularisation(p) =
{
pre =   sy1:UnknownSymptom , (p,sy1):HasAcsSymptoms
effect =    sy1:SymptomsForRev , (p,sy1):HasAcsSymptoms
}

action SymptomsforOMT(p) =
{
pre =   sy1:UnknownSymptom , (p,sy1):HasAcsSymptoms
effect =    sy1:SymptomsForOMT , (p,sy1):HasAcsSymptoms
}

action ProximalLad (p) =
{
pre = sy1:SymptomsForRev   , (p,sy1):HasAcsSymptoms
effect =  sy1:ProximalLad, (p, sy1):HasAcsSymptoms
}

action NonProximalLAD(p) =
{
pre = sy1:SymptomsForRev   , (p,sy1):HasAcsSymptoms
effect =  sy1:NonProximalLAD, (p, sy1 ):HasAcsSymptoms
}

action OtherSymptoms (p) =
{
pre = addsy1:UnknownAdditionalSym,  (p,addsy1):HasAdditionalSymptoms
effect = addsy1:OtherSymptoms,  (p,addsy1):HasAdditionalSymptoms 
}


action  NootherSymptoms (p) =
{
pre = addsy1:UnknownAdditionalSym,  (p,addsy1):HasAdditionalSymptoms
effect = addsy1:NoOtherSymptoms ,  (p,addsy1):HasAdditionalSymptoms 
}


action PrescribePCI(p) = {
pre    = p:Patient, pro1:UnknownProcedure, (p,pro1):HasTreatment
effect = pro1:PCI , (p, pro1):HasTreatment
}
action PrescribeOMT (p) ={
  pre    = p:Patient, pro1:UnknownProcedure, (p,pro1):HasTreatment
  effect =  pro1:OMT  , (p, pro1):HasTreatment
}
action PrescribeFibrinolysis (p) ={
  pre    =  pro1:UnknownProcedure, (p,pro1):HasTreatment
  effect = pro1:ImmFib , (p, pro1):HasTreatment
}
action PrescribeCABG (p) ={
  pre    =  pro1:UnknownProcedure, (p,pro1):HasTreatment
  effect =  pro1:CABG , (p, pro1):HasTreatment
}
action PrescribeCoronaryAngiography(p) ={
  pre    = pro1:UnknownProcedure, (p,pro1):HasTreatment
  effect = pro1:CoroAngiography , (p, pro1):HasTreatment
}
action error (p) =
{
pre =
effect = p:PreConditionAreNotHold
  
}








///////////////////////////////////////

function ObservePCITherapy(p) = {
  ObserveAspirinDose(p)
  |
  ObserveContraindicationForAspirin (p)
}

/*
function PrescribeMedication (p) = {
  switch 
    case dr:Aspirin and (p, dr):HasTherapy => 
    case dr:Clopidogrel and (p, dr):HasTherapy =>
    case dr:GPIIB and (p, dr):HasTherapy =>
    case dr:Heparin and (p, dr):HasTherapy =>
    case dr:Bivalirudin and (p, dr):HasTherapy =>
  }
*/

function ObserveAspirinDose(p) ={
   init TimeIncremented (p);
  switch
    case dr:Aspirin and (p, dr):HasTherapy and no:ContraindicationForAspirinOccurred and (p,no):HasNotification => (Intake_Of_Aspirin_NotAllowed (p); DeleteTherapyDoseTimer(p); ObserveAspirinDose(p) )
    case dr:Aspirin and (p, dr):HasTherapy => (IntakeOfAspirinAllowed (p) ; DeleteTherapyDoseTimer(p); ResetNotification(p); ResetTherapy (p); ObserveAspirinDose(p) )
  }



function ObserveContraindicationForAspirin (p) ={
    init  ContraindicationForTherapy (p);

  switch 
    case co:ContraindicationForAspirin and (p,co):HasContraindication  => (Inform_User_About_Contraindication_Against_Aspirin(p); DeleteContraindicationForAspirin(p); ObserveContraindicationForAspirin (p) )
    case co:ContraindicationForAspirinUnknown and (p,co):HasContraindication =>  ObserveContraindicationForAspirin (p)
  }

action Test (p)= {
  pre =
  effect = p:Test
  }

action IntakeOfAspirinAllowed (p)={
  pre =  no:ContraindicationForAspirinUnknown , (p,no):HasContraindication
  effect = no:IntakeOfAspirinAllowed  , (p,no):HasNotification
}
action Intake_Of_Aspirin_NotAllowed (p)={
  pre =  no:ContraindicationForAspirinOccurred , (p,no):HasNotification
  effect = no:IntakeOfAspirinNotAllowed ,  (p,no):HasNotification
  }


action DeleteContraindicationForAspirin (p) ={
  pre    =  co:ContraindicationForAspirin , (p,co):HasContraindication
  effect =  co:ContraindicationForAspirinUnknown , (p,co):HasContraindication,  no:IntakeOfAspirinUnknown, (p,no):HasNotification

}

action ResetNotification(p)= {
pre    =  no:IntakeOfAspirinAllowed  , (p,no):HasNotification
effect =  no:IntakeOfAspirinUnknown, (p,no):HasNotification
}

action ResetTherapy(p)= {
pre    =  dr:Aspirin , (p, dr):HasTherapy
effect = dr:UnknownTherapy , (p, dr):HasTherapy
}

action DeleteTherapyDoseTimer (p) ={
  pre    =  t:TimeIncremented , (p,t):WaitSince
  effect =  t:UnkonwnTime  , (p, t):WaitSince
}


action IncrementTherapyDoseTimer (p) ={
  pre    =  t:UnkonwnTime  , (p, t):WaitSince
  effect =  t:TimeIncremented , (p,t):WaitSince
}


action Inform_User_About_Contraindication_Against_Aspirin  (p) ={
  pre    =  co:ContraindicationForAspirin  , (p,co):HasContraindication
  effect =  no:ContraindicationForAspirinOccurred, (p,no):HasNotification
}


action PrescribeAspirin (p) ={
  pre    =  dr:UnknownTherapy , (p, dr):HasTherapy 
  effect =  dr:Aspirin , (p, dr):HasTherapy 
}

action PrescribeClopidogrel (p) ={
  pre    =  dr:UnknownTherapy , (p, dr):HasTherapy 
  effect =  dr:Clopidogrel , (p, dr):HasTherapy
}


action PrescribeGPIIb  (p) ={
  pre    =  dr:UnknownTherapy , (p, dr):HasTherapy 
  effect =  dr:GPIIB, (p, dr):HasTherapy
}

action PrescribeHeparin (p) ={
  pre    =  dr:UnknownTherapy , (p, dr):HasTherapy 
  effect =  dr:Heparin , (p, dr):HasTherapy
}

action PrescribeBivalirudin (p) ={
  pre    =  dr:UnknownTherapy , (p, dr):HasTherapy 
  effect =  dr:Bivalirudin , (p, dr):HasTherapy
}




action ContraindicationForAspirin (p) = {
  pre    = co:ContraindicationForAspirinUnknown, (p,co):HasContraindication
  effect = co:ContraindicationForAspirin  , (p,co):HasContraindication
 // effect = co:ContraIndForAspirin1, (p,co):HasContraindication
}



action ContraindicationForHeparin (p) ={
  pre    = co:ContraindicationUnknown, (p,co):HasContraindication
  effect = co:ContraindicationForHeparin , (p,co):HasContraindication
}

action ContraindicationForBivalirudin  (p) ={
  pre    = co:ContraindicationUnknown, (p,co):HasContraindication
  effect = co:ContraindicationForBivalirudin , (p,co):HasContraindication
}

action ContraindicationForClopidogel (p) ={
  pre    = co:ContraindicationUnknown, (p,co):HasContraindication
  effect = co:ContraindicationForClopidogel , (p,co):HasContraindication
}

action ContraindicationForGPIIb (p) ={
  pre    = co:ContraindicationUnknown, (p,co):HasContraindication
  effect = co:ContraindicationForGPIIb, (p,co):HasContraindication
}


action ContraindicationForPCI(p) ={
  pre    = co:ContraindicationForPCI, (p,co):HasContraindication
  effect = co:ContraindicationForPCI , (p,co):HasContraindication
}



function Treatment(p) = {
{
RegisterPatient(p);
AskEKGState(p);
switch 
  case  d1:StableCAD and (p,d1):HasDiagnosis      => StableCADTreatment(p) 
	case  d:STEMI     and (p,d):HasDiagnosis        => STEMITreatment(p)
  case  d:NSTEMI    and (p,d):HasDiagnosis        => NSTEMITreatment(p)

} | init HoldGlobalTreatment(p) }



